# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['HostGroupArgs', 'HostGroup']

@pulumi.input_type
class HostGroupArgs:
    def __init__(__self__, *,
                 description: pulumi.Input[str],
                 type: pulumi.Input[str],
                 assignment_rule: Optional[pulumi.Input[str]] = None,
                 host_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a HostGroup resource.
        :param pulumi.Input[str] description: Description of the host group.
        :param pulumi.Input[str] type: The host group type, case sensitive. (dynamic, static, staticByID)
        :param pulumi.Input[str] assignment_rule: The assignment rule for dynamic host groups.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ids: List of host ids to add to a staticByID host group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: List of hostnames to add to a static host group.
        :param pulumi.Input[str] name: Name of the host group.
        """
        pulumi.set(__self__, "description", description)
        pulumi.set(__self__, "type", type)
        if assignment_rule is not None:
            pulumi.set(__self__, "assignment_rule", assignment_rule)
        if host_ids is not None:
            pulumi.set(__self__, "host_ids", host_ids)
        if hostnames is not None:
            pulumi.set(__self__, "hostnames", hostnames)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def description(self) -> pulumi.Input[str]:
        """
        Description of the host group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: pulumi.Input[str]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        The host group type, case sensitive. (dynamic, static, staticByID)
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="assignmentRule")
    def assignment_rule(self) -> Optional[pulumi.Input[str]]:
        """
        The assignment rule for dynamic host groups.
        """
        return pulumi.get(self, "assignment_rule")

    @assignment_rule.setter
    def assignment_rule(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "assignment_rule", value)

    @property
    @pulumi.getter(name="hostIds")
    def host_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of host ids to add to a staticByID host group.
        """
        return pulumi.get(self, "host_ids")

    @host_ids.setter
    def host_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ids", value)

    @property
    @pulumi.getter
    def hostnames(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of hostnames to add to a static host group.
        """
        return pulumi.get(self, "hostnames")

    @hostnames.setter
    def hostnames(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "hostnames", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the host group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _HostGroupState:
    def __init__(__self__, *,
                 assignment_rule: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 host_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 last_updated: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering HostGroup resources.
        :param pulumi.Input[str] assignment_rule: The assignment rule for dynamic host groups.
        :param pulumi.Input[str] description: Description of the host group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ids: List of host ids to add to a staticByID host group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: List of hostnames to add to a static host group.
        :param pulumi.Input[str] name: Name of the host group.
        :param pulumi.Input[str] type: The host group type, case sensitive. (dynamic, static, staticByID)
        """
        if assignment_rule is not None:
            pulumi.set(__self__, "assignment_rule", assignment_rule)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if host_ids is not None:
            pulumi.set(__self__, "host_ids", host_ids)
        if hostnames is not None:
            pulumi.set(__self__, "hostnames", hostnames)
        if last_updated is not None:
            pulumi.set(__self__, "last_updated", last_updated)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="assignmentRule")
    def assignment_rule(self) -> Optional[pulumi.Input[str]]:
        """
        The assignment rule for dynamic host groups.
        """
        return pulumi.get(self, "assignment_rule")

    @assignment_rule.setter
    def assignment_rule(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "assignment_rule", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        Description of the host group.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="hostIds")
    def host_ids(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of host ids to add to a staticByID host group.
        """
        return pulumi.get(self, "host_ids")

    @host_ids.setter
    def host_ids(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "host_ids", value)

    @property
    @pulumi.getter
    def hostnames(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of hostnames to add to a static host group.
        """
        return pulumi.get(self, "hostnames")

    @hostnames.setter
    def hostnames(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "hostnames", value)

    @property
    @pulumi.getter(name="lastUpdated")
    def last_updated(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "last_updated")

    @last_updated.setter
    def last_updated(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "last_updated", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the host group.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        The host group type, case sensitive. (dynamic, static, staticByID)
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class HostGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assignment_rule: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 host_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        This resource allows you to manage host groups in the CrowdStrike Falcon Platform.

        ## API Scopes

        The following API scopes are required:

        - Host groups | Read & Write
        - Firewall management | Read & Write
        - Prevention policies | Read & Write
        - Response policies | Read & Write
        - Sensor update policies | Read & Write

        ## Example Usage

        ```python
        import pulumi
        import crowdstrike_pulumi as crowdstrike

        dynamic = crowdstrike.HostGroup("dynamic",
            assignment_rule="tags:'SensorGroupingTags/molecule'+os_version:'Debian GNU 11'",
            description="Made with Pulumi",
            type="dynamic")
        static = crowdstrike.HostGroup("static",
            description="Made with Pulumi",
            type="staticByID",
            host_ids=[
                "host1",
                "host2",
            ])
        static_by_id = crowdstrike.HostGroup("staticByID",
            description="Made with Pulumi",
            type="staticByID",
            host_ids=[
                "123123",
                "124124",
            ])
        pulumi.export("hostGroup", dynamic)
        ```

        ## Import

        host group can be imported by specifying the policy id.

        ```sh
        $ pulumi import crowdstrike:index/hostGroup:HostGroup example 7fb858a949034a0cbca175f660f1e769
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] assignment_rule: The assignment rule for dynamic host groups.
        :param pulumi.Input[str] description: Description of the host group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ids: List of host ids to add to a staticByID host group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: List of hostnames to add to a static host group.
        :param pulumi.Input[str] name: Name of the host group.
        :param pulumi.Input[str] type: The host group type, case sensitive. (dynamic, static, staticByID)
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: HostGroupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource allows you to manage host groups in the CrowdStrike Falcon Platform.

        ## API Scopes

        The following API scopes are required:

        - Host groups | Read & Write
        - Firewall management | Read & Write
        - Prevention policies | Read & Write
        - Response policies | Read & Write
        - Sensor update policies | Read & Write

        ## Example Usage

        ```python
        import pulumi
        import crowdstrike_pulumi as crowdstrike

        dynamic = crowdstrike.HostGroup("dynamic",
            assignment_rule="tags:'SensorGroupingTags/molecule'+os_version:'Debian GNU 11'",
            description="Made with Pulumi",
            type="dynamic")
        static = crowdstrike.HostGroup("static",
            description="Made with Pulumi",
            type="staticByID",
            host_ids=[
                "host1",
                "host2",
            ])
        static_by_id = crowdstrike.HostGroup("staticByID",
            description="Made with Pulumi",
            type="staticByID",
            host_ids=[
                "123123",
                "124124",
            ])
        pulumi.export("hostGroup", dynamic)
        ```

        ## Import

        host group can be imported by specifying the policy id.

        ```sh
        $ pulumi import crowdstrike:index/hostGroup:HostGroup example 7fb858a949034a0cbca175f660f1e769
        ```

        :param str resource_name: The name of the resource.
        :param HostGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(HostGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assignment_rule: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 host_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = HostGroupArgs.__new__(HostGroupArgs)

            __props__.__dict__["assignment_rule"] = assignment_rule
            if description is None and not opts.urn:
                raise TypeError("Missing required property 'description'")
            __props__.__dict__["description"] = description
            __props__.__dict__["host_ids"] = host_ids
            __props__.__dict__["hostnames"] = hostnames
            __props__.__dict__["name"] = name
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
            __props__.__dict__["last_updated"] = None
        super(HostGroup, __self__).__init__(
            'crowdstrike:index/hostGroup:HostGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            assignment_rule: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            host_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            hostnames: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            last_updated: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            type: Optional[pulumi.Input[str]] = None) -> 'HostGroup':
        """
        Get an existing HostGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] assignment_rule: The assignment rule for dynamic host groups.
        :param pulumi.Input[str] description: Description of the host group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] host_ids: List of host ids to add to a staticByID host group.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] hostnames: List of hostnames to add to a static host group.
        :param pulumi.Input[str] name: Name of the host group.
        :param pulumi.Input[str] type: The host group type, case sensitive. (dynamic, static, staticByID)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _HostGroupState.__new__(_HostGroupState)

        __props__.__dict__["assignment_rule"] = assignment_rule
        __props__.__dict__["description"] = description
        __props__.__dict__["host_ids"] = host_ids
        __props__.__dict__["hostnames"] = hostnames
        __props__.__dict__["last_updated"] = last_updated
        __props__.__dict__["name"] = name
        __props__.__dict__["type"] = type
        return HostGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="assignmentRule")
    def assignment_rule(self) -> pulumi.Output[Optional[str]]:
        """
        The assignment rule for dynamic host groups.
        """
        return pulumi.get(self, "assignment_rule")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[str]:
        """
        Description of the host group.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="hostIds")
    def host_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        List of host ids to add to a staticByID host group.
        """
        return pulumi.get(self, "host_ids")

    @property
    @pulumi.getter
    def hostnames(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        List of hostnames to add to a static host group.
        """
        return pulumi.get(self, "hostnames")

    @property
    @pulumi.getter(name="lastUpdated")
    def last_updated(self) -> pulumi.Output[str]:
        return pulumi.get(self, "last_updated")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name of the host group.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        The host group type, case sensitive. (dynamic, static, staticByID)
        """
        return pulumi.get(self, "type")

